/*
 * Din_Relay_Lednev_v3.ino
 *
 * Created: 6/11/2015 6:59:26 PM
 * Author: v.lubinrts
 */ 

//  5  -12-2016
//    5 .   3          (  )
//      ( )
//      (!!!  DC   )
//     24VAC
//    AC   ,   .

//  3+.     (    ). 
//   :  
//    -       (   )  ---  
//	  -      --   ,     
//    -       .   ---   ,     
//	  - 

//  3 
//`  pik.h.         (   )
//     
//     ,        20 ,   3 . 
//   ,     3 ,   .   20     
//    ( 1 -  10, 2     )


//  2.  !!!!   
// -    ( ).       LCD-60DA.  
//     -     .          
//   .
//     .      - ,    ,  
//   . 
// -       (    
// -  LCD  NOKIA
// -        ,     (  )
// - 

//    ( ..)
// 4  (   )  .   4   (  -    GND). 
//  2      (   ).
//   
//     ,     - .
//  WDT

#include <TimerOne.h>
#include <pik.h>
#include <avr/wdt.h>
#include <Bounce2.h>
#include <OneWire.h>

float mesDS18x20( void );
int initDS18x20( void );
void zero_crosss_Det( void );
void tikTimer( void );

//   
const byte periodT = 100;		//      100 = 0,1 ,    - 100   10 000
const byte minT = 110;			//   
const byte maxT = 15;			//   

//   (, )
const int buttonAllOff = A7;
volatile const int buttonT1 = A6; 
const int buttonT4 = 9;
const int buttonR1 = A5;
const int buttonR2 = A4;
const int buttonR3 = A3;
const int buttonR4 = A2;
const int buttonR5 = A1;

//  
const int pinT1 = 3;	// Triac1 Dimmer
const int pinT4 = 10;	// Triac
const int pinR1 = 4;	// 
const int pinR2 = 5;	// 
const int pinR3 = 7;	// 
const int pinDS = 8;	//  
const int pinR4 = 12;	// 
const int pinR5 = 13;	// 
const int pinBeep = A0;	// 

const int dOnR1 = 72, dOffR1 = 60; //
const int dOnR2 = 79, dOffR2 = 64; //
const int dOnR3 = 73, dOffR3 = 58; //   36  58
const int dOnR4 = 73, dOffR4 = 59; //
const int dOnR5 = 73, dOffR5 = 62; //

const int dTP = 600;					//   , /  
const unsigned int intCommOff = 3000;	//     

unsigned int intervalMesDS = 180000;	//    

volatile unsigned int tikD1 = 0;					//   ,   
volatile unsigned long int  timePressPinT1 = 0;		//    ,	   -  .
volatile unsigned long int  timePressPinT4 = 0;		//    ,	   -  .
unsigned long int timePressAllOff = 0;				//     ,  -  
unsigned long int timeAllOff = 4294967294;			//    

volatile byte Kdiv = 1;							//     256    ,
volatile int directDimm1 = 1;					//  ,   .  1 -  , -1  .

unsigned long int timeOnR1 = 0;		//    
unsigned long int timeOnR2 = 0;
unsigned long int timeOnR3 = 0;
unsigned long int timeOnR4 = 0;
unsigned long int timeOnR5 = 0;
unsigned long int timeOnT1 = 0;		//    
unsigned long int timeOnT4 = 0;		

//       
unsigned long int  maxTimeR1 = 1000.0*60*10;  // 10  
unsigned long int  maxTimeR2 = 1000.0*60*10;  // 10 
unsigned long int  maxTimeR3 = 1000.0*60*10;  // 10  
unsigned long int  maxTimeR4 = 1000.0*60*10;  // 10 
unsigned long int  maxTimeR5 = 1000.0*60*10;  // 10 
unsigned long int  maxTimeT1 = 1000.0*60*120; // 120 
unsigned long int  maxTimeT4 = 1000.0*60*120; // 120 

// C  (  )
byte statusR1 = 0;
byte statusR2 = 0;
byte statusR3 = 0;
byte statusR4 = 0;
byte statusR5 = 0;
volatile int statusT1 = minT+10;		//   0 - ,  110 - ,    
volatile byte statusT4 = 0;				//      

//    
byte data[12];
byte addr[8];
OneWire  ds( pinDS );
float currentT = -999;					//  

// Instantiate a Bounce object :
Bounce dbR1 = Bounce();
Bounce dbR2 = Bounce();
Bounce dbR3 = Bounce();
Bounce dbR4 = Bounce();
Bounce dbR5 = Bounce();

Pik pikT( pinBeep, 18000000, 3000, 500, 0 );		//   (    )
Pik pikExit( pinBeep, 100000, 10000, 0, 10 );	//    .    
int t8 = 70, N8 = 10;
int t7 = 65, N7 = 5;
int t6 = 60, N6 = 4;
int t5 = 55, N5 = 3;
int t4 = 50, N4 = 2;
int t3 = 45, N3 = 1;
int t2 = 40, N2 = 0;
int t1 = 3, N1 = 0;


void setup()
{	
	delay( 400 );
	wdt_disable(); //     , -     
	
	if( analogRead( buttonAllOff ) < 130 )   //    < 5  -   3
	//if(1)	// !!!!  
	{	//     		 
		t8 = 70; N8 = 8;
		t7 = 60; N7 = 7;
		t6 = 50; N6 = 6;
		t5 = 40; N5 = 5;
		t4 = 30; N4 = 4;
		t3 = 20; N3 = 3;
		t2 = 10; N2 = 2;
		t1 =  0; N1 = 1;
		intervalMesDS = 30000;
	}

	//   		
	//pikExit.set_period( 500, 500 );		// !!!    ,   
	//    ,  -  ,   -  
		pikExit.point_d()[0] = 500;		pikExit.point_d()[1] = 9500;
		pikExit.point_d()[2] = 500;		pikExit.point_d()[3] = 8500;
		pikExit.point_d()[4] = 500;		pikExit.point_d()[5] = 7500;
		pikExit.point_d()[6] = 500;		pikExit.point_d()[7] = 6500;
		pikExit.point_d()[8] = 500;		pikExit.point_d()[9] = 5500;
		pikExit.point_d()[10] = 500;	pikExit.point_d()[11] = 4500;
		pikExit.point_d()[12] = 500;	pikExit.point_d()[13] = 3500;
		pikExit.point_d()[14] = 500;	pikExit.point_d()[15] = 2500;
		pikExit.point_d()[16] = 500;	pikExit.point_d()[17] = 1500;
		pikExit.point_d()[18] = 40000;	pikExit.point_d()[19] = 0;
	
	//       VCC, 
	//        GND
	//   -   LOW
	//   -   HIGH

	//pinMode( A0, INPUT );	digitalWrite( A0, HIGH ) ;    //   pull-up 	
	pinMode( buttonR5, INPUT );		digitalWrite( buttonR5, HIGH );
	pinMode( buttonR4, INPUT );		digitalWrite( buttonR4, HIGH );
	pinMode( buttonR3, INPUT );		digitalWrite( buttonR3, HIGH );
	pinMode( buttonR2, INPUT );		digitalWrite( buttonR2, HIGH );
	pinMode( buttonR1, INPUT );		digitalWrite( buttonR1, HIGH );
	pinMode( buttonT1, INPUT );		digitalWrite( buttonT1, HIGH );
	pinMode( buttonT4, INPUT );		digitalWrite( buttonT4, HIGH );
	
	pinMode( pinR1, OUTPUT );		digitalWrite( pinR1, statusR1 );
	pinMode( pinR2, OUTPUT );		digitalWrite( pinR2, statusR2 );
	pinMode( pinR3, OUTPUT );		digitalWrite( pinR3, statusR3 );
	pinMode( pinR4, OUTPUT );		digitalWrite( pinR4, statusR4 );
	pinMode( pinR5, OUTPUT );		digitalWrite( pinR5, statusR5 );
	pinMode( pinT1, OUTPUT );		//digitalWrite( pinT1, statusT1 );
	pinMode( pinT4, OUTPUT );

	Serial.begin( 57600 );				// 
	Serial.println( "Start......." );	// 	
		
	//      
	dbR1.attach( buttonR1 );		dbR1.interval(5);
    dbR2.attach( buttonR2 );		dbR2.interval(5);
    dbR3.attach( buttonR3 );		dbR3.interval(5);
	dbR4.attach( buttonR4 );		dbR4.interval(5);
	dbR5.attach( buttonR5 );		dbR5.interval(5);
	
	initDS18x20();		//   
	
	//    	
	pikT.On();
	delay( dTP );									//      
	
	attachInterrupt( 0, zero_crosss_Det, RISING );	// LOW RISING FALLING      2,    LOW -- HIGH
	Timer1.initialize( periodT );				// 
	Timer1.attachInterrupt( tikTimer );			//  	
	Timer1.start();
	wdt_enable( WDTO_8S );  //  ,    

}  // end setup()

void loop()
{
	 wdt_reset(); //    "   ",   SS- .

	 //            
     if( (millis()-timeOnR1) > maxTimeR1 ) 
	 {  statusR1 = 0;
		timeOnR1 = 0; 
	    //digitalWrite( pinR1, statusR1 );
	 }
     
	 if( (millis()-timeOnR2) > maxTimeR2 ) 
	 {  statusR2 = 0;
		timeOnR2 = 0; 
	    //digitalWrite( pinR2, statusR2 );
	 }

     if( (millis()-timeOnR3) > maxTimeR3 ) 
	 {  statusR3 = 0;
	 	timeOnR3 = 0; 
	    //digitalWrite( pinR3, statusR3 );
	 }

     if( (millis()-timeOnR4) > maxTimeR4 )
     {	statusR4 = 0;
		timeOnR4 = 0;
	    //digitalWrite( pinR4, statusR4 );
	 }

     if( (millis()-timeOnR5) > maxTimeR5 )
     {	statusR5 = 0;
	     timeOnR5 = 0;
	     //digitalWrite( pinR5, statusR5 );
     }
     
	 if( (millis()-timeOnT1) > maxTimeT1 )
     {  statusT1 = minT+10;	//   . 
	    timeOnT1 = 0;
     }

	 if( (millis()-timeOnT4) > maxTimeT4 )
	 {  statusT4 = 0;
		 timeOnT4 = 0;
	 }


//  
    float  Tt = mesDS18x20( );

//   
	if( Tt != -999 )  
	{	currentT = Tt;
		tempDispl( ); // 
	}

// -------------------------------------------------------
   
  
   //         
   if( analogRead( buttonAllOff ) < 130 )  //   < 5
   {	//Serial.println( "analogRead(buttonAllOff) < 130" );
		delay(20);
		if( timePressAllOff == 0 )	timePressAllOff = millis();    //      
		//  ,    
		
		//       
		if( millis()  > intCommOff+timePressAllOff )
		{	pikExit.On();							//  .
			Serial.println( "pikExit.ON" );
			timePressAllOff = millis();		// ???   +10 000
			timeAllOff = millis() + 8000;			//        
		}       
		
   }   //	if( analogRead( buttonAllOff ) < 130 )
   else timePressAllOff = 0;		//      /
      
   if( millis() > timeAllOff  )	//       
   {   //      
	   		pikExit.Off();
	   		Serial.println( "pikExit.OFF" );
			statusR1 = 0; statusR2 = 0; statusR4 = 0; statusR5 = 0; statusT1 = minT+10;   statusT4 = 0;
	    	timeOnR1 = 0; timeOnR2 = 0; timeOnR3 = 0; timeOnR4 = 0; timeOnR5 = 0; timeOnT1 = 0; timeOnT4 = 0;
	    	statusR3 = 1; delay( 500 ); statusR3 = 0;	//      3 
			//digitalWrite( pinR3, HIGH); delay( 500 ); digitalWrite( pinR3, LOW );     //      3 
			//digitalWrite( pinR1, statusR1 );
      		//digitalWrite( pinR2, statusR2 );	      		
     		//digitalWrite( pinR4, statusR4 );
			//digitalWrite( pinR5, statusR5 );
			timeAllOff = 4294967294;			//  
   }  // end if( )

			  
  // --------------------------------------------------------
   
   // Call code if Bounce fell (transition from HIGH to LOW) :
   dbR1.update();
   if ( dbR1.fell() ) 
   {  //lcd.gotoXY( shiftD, 0); 
	  if( statusR1 == 0 ) 
	  {  statusR1 = 1;
		 timeOnR1 = millis(); //   
		 //lcd.character( '.' );
	  }
	  else	{	//lcd.character( 'X' );  
				statusR1 = 0;
			}
    //digitalWrite( pinR1, statusR1 );
	  
   }
 

   dbR2.update();
   if ( dbR2.fell() )
   {   //lcd.gotoXY( shiftD, 1);
	   if( statusR2 == 0 )
	   {  statusR2 = 1;
		   timeOnR2 = millis(); //   
		   //lcd.character( '.' );
	   }
	   else	{	//lcd.character( 'X' );
				statusR2 = 0;
			}
	   
	   //digitalWrite( pinR2, statusR2 );
	  
   }
   
  
   dbR3.update();
   if ( dbR3.fell() )
   {   //lcd.gotoXY( shiftD, 2);
	   if( statusR3 == 0 )
	   {  statusR3 = 1;
		   timeOnR3 = millis(); //   
		   //lcd.character( '.' );
	   }
	   else	{	//lcd.character( 'X' );
		   statusR3 = 0;
	   }
	   
	   //digitalWrite( pinR3, statusR3 );
	   
   }
 
 
   dbR4.update();  
   if ( dbR4.fell() )
   {   //lcd.gotoXY( shiftD, 3);
	   if( statusR4 == 0 )
	   {  statusR4 = 1;
		   timeOnR4 = millis(); //   
		   //Serial.println( "A2/R4 Press" );
		   //lcd.character( '.' );
	   }
	   else	{	//lcd.character( 'X' );
				statusR4 = 0;
				//Serial.println( "A2/R4 Unpress" );
			}
	   
	   //digitalWrite( pinR4, statusR4 );
	   
   }	


   dbR5.update();
   if ( dbR5.fell() )
   {	//
	   if( statusR5 == 0 )
	   {  statusR5 = 1;
		   timeOnR5 = millis(); //   
	   }
	   else	statusR5 = 0;
	   
	   //digitalWrite( pinR5, statusR5 );
	   
   }
	
  
	if( analogRead( buttonT1 ) < 130   )
	{  // //    ( LOW)
		if( timePressPinT1 == 0 )
		{   delay( 5 );
			timePressPinT1 = millis();
			timeOnT1 = millis();
		}
		
	}  // 
	else
	{	//  
		if( (millis() - timePressPinT1)  <= dTP )
		{	//    ,   ,    -    
			//delay( 5 );
				if( statusT1 > (minT-10) )	statusT1 = maxT+20;    //      5  +10
				else	{  statusT1 = minT;  delay(5); }
		}   //	end if( millis() - timePressPinT1  <= dTP )
		
		timePressPinT1 = 0;	//    
		
	}  	


	if( digitalRead( buttonT4 ) == LOW   )
	{  //   ( LOW)
		if( timePressPinT4 == 0 )
		{   delay( 5 );
			timePressPinT4 = millis();
			timeOnT4 = millis();
		}
		
	}  
	else
	{	//  
		if( (millis() - timePressPinT4)  <= dTP )
		{	//    ,   ,    -    
			//delay( 5 );
			if( statusT4 == HIGH )	statusT4 = LOW;
			else	{  statusT4 = HIGH;  delay(5); }
		}   //	end if( millis() - timePressPinT4  <= dTP )
		
		timePressPinT4 = 0;	//    
		
	}


	//statusT4 = 50;
	//Serial.println( analogRead( buttonAllOff ) );
	//Serial.println( statusR1 );
	//Serial.println( tikD1 );

	//delay( 20 );

}  // end loop()


int initDS18x20( )
{	//  
	//   0 -   , 1 -  ,    
	ds.reset_search();
	
	if ( !ds.search(addr) )
	{
		//Serial.println("No more addresses.");
		//Serial.println();
		ds.reset_search();
		delay(250);				//    ,        
		return 0;
	}
	
	if( OneWire::crc8( addr, 7 ) != addr[7])
	{	//Serial.println("CRC is not valid!");
		return 0;
	}
	
	//Serial.println( "Find sensor...." );
	return 1;
	
}  //  end initDS18x20( )

float mesDS18x20( )
{	//      -999 -     
	//   Delay()     ( intervalMesDS)
 	static byte state = 0;					//	0 -  , 1 -   ,  
	static unsigned long timeStartMes = 0;	//	     
	static unsigned long timeMes = 0;		//	   
	const int delayMesDS = 800;				//	  
	float celsius;							//	    
	
	//   intervalMesDS -      
	if( state == 0  && ( (millis()-timeMes) > intervalMesDS) )
	{	//   
		state = 1;
		ds.reset();
		ds.select(addr);
		ds.write(0x44,1);         // start conversion, with parasite power on at the end
		//   750,
		timeStartMes = millis();
		return -999;
	}
	
	if( state == 1 )
	{	//         delayMesDS 
		if( millis() - timeStartMes  < delayMesDS ) return -999;
		
		//  ,  
		//delay( 750 );     // maybe 750ms is enough, maybe not
		
		//   .  
		//     -  0.
		byte present = ds.reset();    //    .   
		ds.select( addr );
		ds.write( 0xBE );         // Read Scratchpad

		//Serial.print( "  Data = " );
		//Serial.print( present, HEX );
		//Serial.print( " " );
		for ( int i = 0; i < 9; i++)
		{       // we need 9 bytes
			data[i] = ds.read();
			//Serial.print(data[i], HEX);
			//Serial.print(" ");
		}    //end for()

		// convert the data to actual temperature

		unsigned int raw = (data[1] << 8) | data[0];
		byte cfg = (data[4] & 0x60);
		if(cfg == 0x00) raw = raw << 3;			// 9 bit resolution, 93.75 ms
		else if (cfg == 0x20) raw = raw << 2;	// 10 bit res, 187.5 ms
		else if (cfg == 0x40) raw = raw << 1;	// 11 bit res, 375 ms
		// default is 12 bit resolution, 750 ms conversion time
		
		celsius = (float)raw / 16.0;
		
		timeMes = millis();	//    
		timeStartMes = 0;		
		state = 0;			//    
		return celsius;
	}
	
	return -999;

}    // mesDS18x20( byte satate )


void tempDispl(  )
{	
	Serial.print( "Temp: ");
	Serial.print( currentT );
	Serial.print( "   Millis(): ");
	Serial.println( millis() ); 
	
	pikT.reset(); //     (  )

	if( currentT >= t8 ) { pikT.set_N( N8 );  statusT1 = minT; return; }	//  ,  
	if( currentT >= t7 ) { pikT.set_N( N7 );  statusT1 += 3;   return; }	// ,    
	if( currentT >= t6 ) { pikT.set_N( N6 );  return; }						// ,    
	if( currentT >= t5 ) { pikT.set_N( N5 );  return; }
	if( currentT >= t4 ) { pikT.set_N( N4 );  return; }
	if( currentT >= t3 ) { pikT.set_N( N3 );  return; }
	if( currentT >= t2 ) { pikT.set_N( N2 );  return; }
	if( currentT >= t1 ) { pikT.set_N( N1 );  return; }		
	

	//if( currentT >= 30 ) { pikT.set_N( 4 );  return; }
	//if( currentT >= 20 ) { pikT.set_N( 3 );  return; }
	
}  //  end  tempDispl( float t )


void display()
{	//        ,    	
		
	//lcd.gotoXY( shiftD, 0);	if( statusR1 == 0 )  lcd.character( 'X' ); else lcd.character( '-' ); 
	//lcd.gotoXY( shiftD, 1); 	if( statusR2 == 0 )  lcd.character( 'X' ); else lcd.character( '-' );
	//lcd.gotoXY( shiftD, 2); 	if( statusR3 == 0 )  lcd.character( 'X' ); else lcd.character( '-' );
	//lcd.gotoXY( shiftD, 3); 	if( statusR4 == 0 )  lcd.character( 'X' ); else lcd.character( '-' );
	
}  // end display()



void zero_crosss_Det()
{   //        

 Timer1.stop();
 digitalWrite( pinT1, LOW );		
 digitalWrite( pinT4, LOW );
 
 tikD1 = 0;		
 Timer1.restart();					
	
}	// end zeero_cross_Det()



void tikTimer(void)
{
	pikT.mainPik();
	pikExit.mainPik();
		
	Kdiv++;
	tikD1++;

	if( tikD1 > statusT1 ) digitalWrite( pinT1, HIGH );
	digitalWrite( pinT4, statusT4 );
	
	if( statusR1 == 1 && tikD1 == dOnR1 ) digitalWrite( pinR1, HIGH );
	if( statusR1 == 0 && tikD1 == dOffR1) digitalWrite( pinR1, LOW );

	if( statusR2 == 1 && tikD1 == dOnR2 ) digitalWrite( pinR2, HIGH );
	if( statusR2 == 0 && tikD1 == dOffR2) digitalWrite( pinR2, LOW );
	
	if( statusR3 == 1 && tikD1 == dOnR3 ) digitalWrite( pinR3, HIGH );
	if( statusR3 == 0 && tikD1 == dOffR3) digitalWrite( pinR3, LOW );

	if( statusR4 == 1 && tikD1 == dOnR4 ) digitalWrite( pinR4, HIGH );
	if( statusR4 == 0 && tikD1 == dOffR4) digitalWrite( pinR4, LOW );
	
	if( statusR5 == 1 && tikD1 == dOnR5 ) digitalWrite( pinR5, HIGH );
	if( statusR5 == 0 && tikD1 == dOffR5) digitalWrite( pinR5, LOW );
	
	if( Kdiv == 0  &&  analogRead( buttonT1 ) < 130  )
	{	//     256         
		//     ,     256 
		statusT1 += directDimm1;
		if( statusT1 > minT-20 ) directDimm1 = -1;
		if( statusT1 < maxT+10 ) directDimm1 = 1;
			
	}

}	// end void tikTimer(void)

	